import os

class tests:
    def __init__(self):

        self.sklad = {5: ['1. Набор данных: regression/international_airline_passengers.csv. Используя библиотеку PyTorch, решите задачу предсказания числа международных авиапассажиров . Разделите набор данных на обучающее и тестовое множество в пропорции 80/20. Выполните предобработку данных: преобразуйте даты в числовой формат, нормализуйте данные. Постройте модель нейронной сети, состоящую из нескольких полносвязных слоев. Сравните эффективность оптимизаторов SGD, Adam и AdamW при обучении модели. Для каждого оптимизатора постройте график изменения функции потерь на обучающем и валидационном множествах в процессе обучения. Оцените качество моделей с разными оптимизаторами на тестовом множестве, вычислив значения MSE, MAE и R2. Сделайте выводы о влиянии выбора оптимизатора на процесс обучения и итоговое качество модели. В качестве бонусного задания предложите студентам попробовать различные архитектуры нейросетей и сравнить их эффективность.', 
[
'''
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
from sklearn.model_selection import train_test_split
from sklearn.preprocessing import MinMaxScaler
from sklearn.metrics import mean_squared_error, mean_absolute_error, r2_score
import torch
import torch.nn as nn
import torch.optim as optim

# Load the dataset
data_path = 'regression/international_airline_passengers.csv'
data = pd.read_csv(data_path)

# Convert the month column to datetime and extract numerical representation of the date
data['Month'] = pd.to_datetime(data['Month'])
data['Date'] = data['Month'].map(lambda x: x.toordinal())

# Select the numerical features and target variable
data = data[['Date', 'Passengers']]

# Normalize the data
scaler = MinMaxScaler()
data_scaled = scaler.fit_transform(data)

# Split the dataset into train and test sets (80/20)
train_data, test_data = train_test_split(data_scaled, test_size=0.2, random_state=42, shuffle=False)

# Prepare data for PyTorch
train_x = torch.tensor(train_data[:, 0].reshape(-1, 1), dtype=torch.float32)
train_y = torch.tensor(train_data[:, 1].reshape(-1, 1), dtype=torch.float32)

test_x = torch.tensor(test_data[:, 0].reshape(-1, 1), dtype=torch.float32)
test_y = torch.tensor(test_data[:, 1].reshape(-1, 1), dtype=torch.float32)
''',
'''
# Define the neural network model
class NeuralNet(nn.Module):
    def __init__(self):
        super(NeuralNet, self).__init__()
        self.layers = nn.Sequential(
            nn.Linear(1, 64),
            nn.ReLU(),
            nn.Linear(64, 32),
            nn.ReLU(),
            nn.Linear(32, 1)
        )

    def forward(self, x):
        return self.layers(x)

# Define training function
def train_model(optimizer_name):
    model = NeuralNet()
    criterion = nn.MSELoss()

    if optimizer_name == "SGD":
        optimizer = optim.SGD(model.parameters(), lr=0.01)
    elif optimizer_name == "Adam":
        optimizer = optim.Adam(model.parameters(), lr=0.01)
    elif optimizer_name == "AdamW":
        optimizer = optim.AdamW(model.parameters(), lr=0.01)
    else:
        raise ValueError("Unsupported optimizer")

    train_losses = []
    val_losses = []

    for epoch in range(100):
        # Training phase
        model.train()
        optimizer.zero_grad()
        predictions = model(train_x)
        loss = criterion(predictions, train_y)
        loss.backward()
        optimizer.step()
        train_losses.append(loss.item())

        # Validation phase
        model.eval()
        with torch.no_grad():
            val_predictions = model(test_x)
            val_loss = criterion(val_predictions, test_y)
            val_losses.append(val_loss.item())

    return model, train_losses, val_losses
''',
'''
# Train models with different optimizers
optimizers = ["SGD", "Adam", "AdamW"]
results = {}

for optimizer in optimizers:
    model, train_losses, val_losses = train_model(optimizer)
    results[optimizer] = {
        "model": model,
        "train_losses": train_losses,
        "val_losses": val_losses
    }

    # Evaluate the model on test data
    model.eval()
    with torch.no_grad():
        test_predictions = model(test_x).numpy()
        test_y_np = test_y.numpy()
        mse = mean_squared_error(test_y_np, test_predictions)
        mae = mean_absolute_error(test_y_np, test_predictions)
        r2 = r2_score(test_y_np, test_predictions)

    results[optimizer]["metrics"] = {"MSE": mse, "MAE": mae, "R2": r2}
''',
'''
# Plot loss curves for each optimizer
plt.figure(figsize=(12, 6))
for optimizer in optimizers:
    plt.plot(results[optimizer]["train_losses"], label=f"{optimizer} - Train")
    plt.plot(results[optimizer]["val_losses"], label=f"{optimizer} - Validation")
plt.xlabel("Epoch")
plt.ylabel("Loss")
plt.legend()
plt.title("Training and Validation Loss for Different Optimizers")
plt.show()

# Print metrics for each optimizer
for optimizer in optimizers:
    print(f"Optimizer: {optimizer}")
    print(f"MSE: {results[optimizer]['metrics']['MSE']:.4f}")
    print(f"MAE: {results[optimizer]['metrics']['MAE']:.4f}")
    print(f"R2: {results[optimizer]['metrics']['R2']:.4f}")
    print("---")
''']],

1:['2. Набор данных: Movie_regression.xls (https://www.kaggle.com/datasets/balakrishcodes/others/data). Используя библиотеку PyTorch, решите задачу предсказания столбца `Marketing Expense` (задача регрессии). Разделите набор данных на обучающее и тестовое множество. Выполните предобработку данных (корректно обработайте случаи категориальных и нечисловых столбцов, при наличии). Сравните несколько нескольких различных архитектур нейронных сетей и графически продемонстрируйте, как выбор архитектуры влияет на процесс обучения и результаты на тестовом множестве',
['''
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
from sklearn.model_selection import train_test_split
from sklearn.preprocessing import StandardScaler, OneHotEncoder
from sklearn.compose import ColumnTransformer
from sklearn.pipeline import Pipeline
from sklearn.metrics import mean_squared_error, mean_absolute_error, r2_score
import torch
import torch.nn as nn
import torch.optim as optim

# Load the dataset
data_path = 'Movie_regression.xls'
data = pd.read_excel(data_path)

# Define the target and features
target_column = 'Marketing Expense'
X = data.drop(columns=[target_column])
y = data[target_column]
''',
'''
# Handle categorical and numerical columns
categorical_cols = X.select_dtypes(include=['object']).columns
numerical_cols = X.select_dtypes(include=['number']).columns

# Preprocessing pipeline
preprocessor = ColumnTransformer(
    transformers=[
        ('num', StandardScaler(), numerical_cols),
        ('cat', OneHotEncoder(), categorical_cols)
    ])

# Apply preprocessing
X_transformed = preprocessor.fit_transform(X)
y = y.values

# Split the dataset into train and test sets (80/20)
X_train, X_test, y_train, y_test = train_test_split(X_transformed, y, test_size=0.2, random_state=42)

# Convert data to PyTorch tensors
X_train = torch.tensor(X_train, dtype=torch.float32)
y_train = torch.tensor(y_train.reshape(-1, 1), dtype=torch.float32)
X_test = torch.tensor(X_test, dtype=torch.float32)
y_test = torch.tensor(y_test.reshape(-1, 1), dtype=torch.float32)
''',
'''
# Define neural network architectures
class SimpleNet(nn.Module):
    def __init__(self, input_dim):
        super(SimpleNet, self).__init__()
        self.layers = nn.Sequential(
            nn.Linear(input_dim, 64),
            nn.ReLU(),
            nn.Linear(64, 1)
        )

    def forward(self, x):
        return self.layers(x)

class DeepNet(nn.Module):
    def __init__(self, input_dim):
        super(DeepNet, self).__init__()
        self.layers = nn.Sequential(
            nn.Linear(input_dim, 128),
            nn.ReLU(),
            nn.Linear(128, 64),
            nn.ReLU(),
            nn.Linear(64, 32),
            nn.ReLU(),
            nn.Linear(32, 1)
        )

    def forward(self, x):
        return self.layers(x)

# Define training function
def train_model(model, optimizer_name):
    criterion = nn.MSELoss()

    if optimizer_name == "SGD":
        optimizer = optim.SGD(model.parameters(), lr=0.01)
    elif optimizer_name == "Adam":
        optimizer = optim.Adam(model.parameters(), lr=0.01)
    else:
        raise ValueError("Unsupported optimizer")

    train_losses = []
    val_losses = []

    for epoch in range(100):
        # Training phase
        model.train()
        optimizer.zero_grad()
        predictions = model(X_train)
        loss = criterion(predictions, y_train)
        loss.backward()
        optimizer.step()
        train_losses.append(loss.item())

        # Validation phase
        model.eval()
        with torch.no_grad():
            val_predictions = model(X_test)
            val_loss = criterion(val_predictions, y_test)
            val_losses.append(val_loss.item())

    return model, train_losses, val_losses
''',
'''
# Train and evaluate different architectures
input_dim = X_train.shape[1]
architectures = {
    "SimpleNet": SimpleNet(input_dim),
    "DeepNet": DeepNet(input_dim)
}

results = {}

for name, model in architectures.items():
    print(f"Training {name}...")
    model, train_losses, val_losses = train_model(model, "Adam")
    results[name] = {
        "model": model,
        "train_losses": train_losses,
        "val_losses": val_losses
    }

    # Evaluate the model on test data
    model.eval()
    with torch.no_grad():
        test_predictions = model(X_test).numpy()
        y_test_np = y_test.numpy()
        mse = mean_squared_error(y_test_np, test_predictions)
        mae = mean_absolute_error(y_test_np, test_predictions)
        r2 = r2_score(y_test_np, test_predictions)

    results[name]["metrics"] = {"MSE": mse, "MAE": mae, "R2": r2}
''',
'''
# Plot loss curves for each architecture
plt.figure(figsize=(12, 6))
for name in architectures.keys():
    plt.plot(results[name]["train_losses"], label=f"{name} - Train")
    plt.plot(results[name]["val_losses"], label=f"{name} - Validation")
plt.xlabel("Epoch")
plt.ylabel("Loss")
plt.legend()
plt.title("Training and Validation Loss for Different Architectures")
plt.show()

# Print metrics for each architecture
for name in architectures.keys():
    print(f"Architecture: {name}")
    print(f"MSE: {results[name]['metrics']['MSE']:.4f}")
    print(f"MAE: {results[name]['metrics']['MAE']:.4f}")
    print(f"R2: {results[name]['metrics']['R2']:.4f}")
    print("---")
'''

]],
2   :['3. Набор данных: https://www.kaggle.com/datasets/marquis03/flower-classification. Реализовав сверточную нейронную сеть при помощи библиотеки PyTorch, решите задачу классификации изображений. Разделите набор данных на обучающее и тестовое множество. Выполните предобработку данных (приведите изображения к одному размеру, нормализуйте и преобразуйте изображения в тензоры). Проведите серию экспериментов, варьируя количество сверточных блоков (свертка, активация, пулинг) в архитектуре нейронной сети. Графически отобразите зависимость качества классификации на валидационном множестве (метрика micro F1) от количества сверточных блоков. Выберите лучшую архитектуру и оцените ее производительность на тестовом множестве. Проанализируйте, какие виды цветов распознаются хуже всего',
['''
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
from sklearn.model_selection import train_test_split
from sklearn.preprocessing import StandardScaler, OneHotEncoder
from sklearn.compose import ColumnTransformer
from sklearn.pipeline import Pipeline
from sklearn.metrics import f1_score, classification_report
import torch
import torch.nn as nn
import torch.optim as optim
from torch.utils.data import DataLoader, Dataset
from torchvision import transforms, datasets

# Dataset path and preprocessing
DATA_PATH = 'flower-classification-dataset/'  # Update to your dataset path

# Define transformations for the dataset
transform = transforms.Compose([
    transforms.Resize((128, 128)),  # Resize images to 128x128
    transforms.ToTensor(),         # Convert images to tensors
    transforms.Normalize(mean=[0.5, 0.5, 0.5], std=[0.5, 0.5, 0.5])  # Normalize
])

# Load datasets
train_dataset = datasets.ImageFolder(root=f"{DATA_PATH}/train", transform=transform)
val_dataset = datasets.ImageFolder(root=f"{DATA_PATH}/val", transform=transform)
test_dataset = datasets.ImageFolder(root=f"{DATA_PATH}/test", transform=transform)

# Data loaders
train_loader = DataLoader(train_dataset, batch_size=32, shuffle=True)
val_loader = DataLoader(val_dataset, batch_size=32, shuffle=False)
test_loader = DataLoader(test_dataset, batch_size=32, shuffle=False)

''',
'''
# Define Convolutional Neural Network architectures
class ConvNet(nn.Module):
    def __init__(self, num_classes, num_blocks):
        super(ConvNet, self).__init__()
        layers = []
        in_channels = 3

        for _ in range(num_blocks):
            layers.append(nn.Conv2d(in_channels, 32, kernel_size=3, padding=1))
            layers.append(nn.ReLU())
            layers.append(nn.MaxPool2d(kernel_size=2))
            in_channels = 32

        self.conv = nn.Sequential(*layers)
        self.fc = nn.Sequential(
            nn.Flatten(),
            nn.Linear(32 * (128 // (2 ** num_blocks)) ** 2, 128),
            nn.ReLU(),
            nn.Linear(128, num_classes)
        )

    def forward(self, x):
        x = self.conv(x)
        x = self.fc(x)
        return x

# Training function
def train_model(model, optimizer_name, num_epochs=10):
    criterion = nn.CrossEntropyLoss()

    if optimizer_name == "SGD":
        optimizer = optim.SGD(model.parameters(), lr=0.01, momentum=0.9)
    elif optimizer_name == "Adam":
        optimizer = optim.Adam(model.parameters(), lr=0.001)
    else:
        raise ValueError("Unsupported optimizer")

    train_losses = []
    val_losses = []
    val_f1_scores = []

    for epoch in range(num_epochs):
        model.train()
        running_loss = 0.0

        for images, labels in train_loader:
            images, labels = images.to(device), labels.to(device)

            optimizer.zero_grad()
            outputs = model(images)
            loss = criterion(outputs, labels)
            loss.backward()
            optimizer.step()

            running_loss += loss.item()

        train_losses.append(running_loss / len(train_loader))

        # Validation phase
        model.eval()
        val_loss = 0.0
        all_preds = []
        all_labels = []

        with torch.no_grad():
            for images, labels in val_loader:
                images, labels = images.to(device), labels.to(device)
                outputs = model(images)
                loss = criterion(outputs, labels)

                val_loss += loss.item()
                preds = torch.argmax(outputs, axis=1)
                all_preds.extend(preds.cpu().numpy())
                all_labels.extend(labels.cpu().numpy())

        val_losses.append(val_loss / len(val_loader))
        val_f1 = f1_score(all_labels, all_preds, average="micro")
        val_f1_scores.append(val_f1)

        print(f"Epoch {epoch+1}/{num_epochs}, Train Loss: {train_losses[-1]:.4f}, Val Loss: {val_losses[-1]:.4f}, Val F1: {val_f1:.4f}")

    return model, train_losses, val_losses, val_f1_scores
''',
'''
# Device configuration
device = torch.device("cuda" if torch.cuda.is_available() else "cpu")

# Experiment with varying number of convolutional blocks
num_classes = len(train_dataset.classes)
results = {}

for num_blocks in [1, 2, 3, 4]:
    print(f"Training ConvNet with {num_blocks} convolutional blocks...")
    model = ConvNet(num_classes=num_classes, num_blocks=num_blocks).to(device)
    model, train_losses, val_losses, val_f1_scores = train_model(model, optimizer_name="Adam", num_epochs=10)

    results[num_blocks] = {
        "model": model,
        "train_losses": train_losses,
        "val_losses": val_losses,
        "val_f1_scores": val_f1_scores
    }

# Plot validation F1 scores for different architectures
plt.figure(figsize=(10, 6))
for num_blocks, result in results.items():
    plt.plot(result["val_f1_scores"], label=f"{num_blocks} Conv Blocks")
plt.xlabel("Epoch")
plt.ylabel("Validation Micro F1 Score")
plt.title("Validation F1 Score vs. Number of Conv Blocks")
plt.legend()
plt.show()

# Evaluate the best model on test data
best_num_blocks = max(results, key=lambda x: max(results[x]["val_f1_scores"]))
best_model = results[best_num_blocks]["model"]

best_model.eval()
all_preds = []
all_labels = []

with torch.no_grad():
    for images, labels in test_loader:
        images, labels = images.to(device), labels.to(device)
        outputs = best_model(images)
        preds = torch.argmax(outputs, axis=1)
        all_preds.extend(preds.cpu().numpy())
        all_labels.extend(labels.cpu().numpy())

print("Classification Report on Test Data:")
print(classification_report(all_labels, all_preds, target_names=test_dataset.classes))
''']]
            
        
        }

        self.themes = [{values[0]:keys} for keys,values in self.sklad.items()]
    
    def search(self, text):
        ress = []
        for theme in self.themes:
            for key, value in theme.items():
                if text in key:
                    ress += [f"{key} : {value}"]
        return ress
